"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
require("../../../client/dist/internal/logger/index.cjs");
const api = require("../../../client/dist/scw/api.cjs");
const marshalling = require("../../../client/dist/helpers/marshalling.cjs");
require("../../../client/dist/vendor/base64/index.cjs");
const resourcePaginator = require("../../../client/dist/scw/fetch/resource-paginator.cjs");
const marshalling_gen = require("./marshalling.gen.cjs");
class PublicCatalogAPI extends api.API {
  pageOfListPublicCatalogProducts = (request = {}) => this.client.fetch(
    {
      method: "GET",
      path: `/product-catalog/v2alpha1/public-catalog/products`,
      urlParams: marshalling.urlParams(
        ["page", request.page],
        [
          "page_size",
          request.pageSize ?? this.client.settings.defaultPageSize
        ]
      )
    },
    marshalling_gen.unmarshalListPublicCatalogProductsResponse
  );
  /**
   * List all available products. List all available products in the Scaleway catalog. Returns a complete list of products with their corresponding description, locations, prices and properties. You can define the `page` number and `page_size` for your query in the request.
   *
   * @param request - The request {@link PublicCatalogApiListPublicCatalogProductsRequest}
   * @returns A Promise of ListPublicCatalogProductsResponse
   */
  listPublicCatalogProducts = (request = {}) => resourcePaginator.enrichForPagination(
    "products",
    this.pageOfListPublicCatalogProducts,
    request
  );
}
exports.PublicCatalogAPI = PublicCatalogAPI;
