import "../../../client/dist/internal/logger/index.js";
import { API as API$1 } from "../../../client/dist/scw/api.js";
import { urlParams } from "../../../client/dist/helpers/marshalling.js";
import "../../../client/dist/vendor/base64/index.js";
import { enrichForPagination } from "../../../client/dist/scw/fetch/resource-paginator.js";
import { unmarshalListPublicCatalogProductsResponse } from "./marshalling.gen.js";
class PublicCatalogAPI extends API$1 {
  pageOfListPublicCatalogProducts = (request = {}) => this.client.fetch(
    {
      method: "GET",
      path: `/product-catalog/v2alpha1/public-catalog/products`,
      urlParams: urlParams(
        ["page", request.page],
        [
          "page_size",
          request.pageSize ?? this.client.settings.defaultPageSize
        ]
      )
    },
    unmarshalListPublicCatalogProductsResponse
  );
  /**
   * List all available products. List all available products in the Scaleway catalog. Returns a complete list of products with their corresponding description, locations, prices and properties. You can define the `page` number and `page_size` for your query in the request.
   *
   * @param request - The request {@link PublicCatalogApiListPublicCatalogProductsRequest}
   * @returns A Promise of ListPublicCatalogProductsResponse
   */
  listPublicCatalogProducts = (request = {}) => enrichForPagination(
    "products",
    this.pageOfListPublicCatalogProducts,
    request
  );
}
export {
  PublicCatalogAPI
};
